package com.steerinfo.meterwork.meterworkmeterprocess.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkmeterprocess.model.MeterWorkMeterProcess;
import com.steerinfo.meterwork.meterworkmeterprocess.service.IMeterWorkMeterProcessService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkMeterProcess RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-10-19 02:34
 * 类描述
 * 修订历史：
 * 日期：2020-10-19
 * 作者：generator
 * 参考：
 * 描述：MeterWorkMeterProcess RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterworkmeterprocesss")
@Api(value = "/${api.version}/meterworkmeterprocesss", tags = "计量流程配置 - MeterWorkMeterProcessController")
public class MeterWorkMeterProcessController extends BaseRESTfulController {

    @Autowired
    IMeterWorkMeterProcessService meterWorkMeterProcessService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkmeterprocess:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkMeterProcess> list = meterWorkMeterProcessService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkmeterprocess:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkMeterProcess> list = meterWorkMeterProcessService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkMeterProcess对象创建")
    @ApiImplicitParam(name = "meterWorkMeterProcess", value = "详细实体meterWorkMeterProcess", required = true, dataType = "MeterWorkMeterProcess")
    //@RequiresPermissions("meterworkmeterprocess:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkMeterProcess model) {
        try {
            MeterWorkMeterProcess meterWorkMeterProcess = meterWorkMeterProcessService.add(model);
            return success(meterWorkMeterProcess);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkmeterprocess:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterWorkMeterProcess meterWorkMeterProcess = meterWorkMeterProcessService.getById(id);
            return success(meterWorkMeterProcess);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterWorkMeterProcess信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterWorkMeterProcess", value = "详细实体meterWorkMeterProcess", required = true, dataType = "MeterWorkMeterProcess")
    })
    //@RequiresPermissions("meterworkmeterprocess:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkMeterProcess model) {
        try {
            model.setId(id);
            MeterWorkMeterProcess meterWorkMeterProcess = meterWorkMeterProcessService.modify(model);
            return success(meterWorkMeterProcess);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkmeterprocess:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterWorkMeterProcessService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkMeterProcess对象创建")
    @ApiImplicitParam(name = "meterWorkMeterProcess", value = "详细实体meterWorkMeterProcess", required = true, dataType = "MeterWorkMeterProcess")
    //@RequiresPermissions("meterbaserailwayweight:create")
    @PostMapping(value = "/add")
    public RESTfulResult checkandadd(@RequestBody MeterWorkMeterProcess model) {
        RESTfulResult rm = failed();
        try {
            MeterWorkMeterProcess mbrw = meterWorkMeterProcessService.checkandadd(model);
            if (mbrw != null) {
                return success(mbrw);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "修改", notes = "根据MeterWorkMeterProcess对象修改")
    @PostMapping(value = "/update")
    public RESTfulResult checkandupdate(@RequestBody MeterWorkMeterProcess model) {
        RESTfulResult rm = failed();
        try {
            int num = meterWorkMeterProcessService.checkandupdate(model);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "删除/停用", notes = "根据MeterWorkMeterProcess对象停用")
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<MeterWorkMeterProcess> models) {
        RESTfulResult rm = failed();
        try {
            int num = meterWorkMeterProcessService.abolish(models);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "启用", notes = "根据MeterWorkMeterProcess对象启用")
    @PostMapping(value = "/recover")
    public RESTfulResult recover(@RequestBody List<MeterWorkMeterProcess> models) {
        RESTfulResult rm = failed();
        try {
            int num = meterWorkMeterProcessService.recover(models);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

}
